/*******************************************************************************
*
* File Name:   display.c
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               Init Display -> display_init(void);
*                                               ein Zeichen aus data in den Displayspeicher schreiben-> write_data(char data);
*                                               Positioniert den Cursor -> cursor_position(int zeile, int spalte);
*                                               Schreibt einen String auf das Display -> display_ausgabe(char *format, ...)
*                                               ein befehl an das Display senden -> befehl_schicken(unsigned char befehl)
*
* Copyright (c) 2006 Institut fuer Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
*
*the display source is based on display.c ver 1.0 by Benjamin Benz 20.12.05
*Copyright (c) 2005, 59 Temple Place, Suite 330, Boston,MA 02111-1307, USA.
*
****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/

#include "display.h"

#ifdef F_CPU
#undef F_CPU
#endif
#define F_CPU 16000000UL
#include <util/delay.h>


int x,j;

static char puffer[PUFFER_GROESSE];	/*string fuer Displayausgaben */


void write_data(char data){ //ein Zeichen aus data in den Displayspeicher schreiben


	for (x=0;x<100 ;x++ )
      {
       for (j=0;j<200 ;j++ ){ __asm volatile("nop"); }
       }

	schieberegister_data_schicken(0x38,(1<<1),0x04);

	PORTC &= ~0x07;   // Alles zurueck setzen ==> Fallende Flanke von Enable  portc &=~ 0x07 (&=~0b111)



	for (x=0;x<40 ;x++ )
	  {
      for (j=0;j<200 ;j++ ){ __asm volatile("nop"); }
       }

	schieberegister_data_schicken(data,(1<<1),0x04|(1<<0));

		// Enable muss fuer mind. 450 ns High bleiben, bevor es fallen darf!
		// ==> Also mind. 8 Zyklen warten
	_delay_us(47);  	 // 47 Mikrosekunden warten,

      PORTC &= ~0x07;
}
//-------------------------------------------------------------------------------------------------------------------------------------------------------------
void befehl_schicken(unsigned char befehl)		//    1) ein Befehl(Kommando) an das Display senden

{
	schieberegister_data_schicken(befehl,(1<<1),0x04);       /*SRCLK = PORTC.1 = 1 und RCLK=PC2=1*/

	_delay_us(47); // 47 Mikrosekunden warten

	PORTC &= ~0x07;

}
//----------------------------------------------------------------------------------------------------------------------------------------------------------------
/*Positioniert den Cursor*/
void cursor_position (int zeile, int spalte) {
   switch (zeile) {
    case 1:
		befehl_schicken(0x80 + spalte - 1);
		break;
    case 2:
		befehl_schicken(0xc0 + spalte - 1);
		break;
    case 3:
		befehl_schicken(0x94 + spalte - 1);
		break;
    case 4:
		befehl_schicken(0xd4 + spalte - 1);
		break;
    default: break;
   }
}
//------------------------------------------------------------------------------------------------------------------------------------------------------
/*Schreibt einen String auf das Display.*/
void display_ausgabe(char *format, ...) {

	unsigned int zeichen = 0;
	va_list	args;

	/* Sicher gehen, das der zur Verfuegung stehende Puffer nicht
	 * ueberschrieben wird. */
	va_start(args, format);
	vsnprintf(puffer, PUFFER_GROESSE, format, args);
	va_end(args);

	/* Ausgeben bis Puffer leer ist */
	while(puffer[zeichen] != '\0') {
		write_data(puffer[zeichen]);
		zeichen++;
	}
	return;
}
//-----------------------------------------------------------------------------------------------------------------------------------------------------
/* Initialisiert das Display */
void display_init(void)
{
	schieberegister_init();

	DDRC |= 0x07;		// Ausgaenge
	DDRC &= ~(1<<5);		// Eingaenge   DISPLAY_IN =(1<<5)	/*!< Input-Pins Display */

	for (x=0;x<100 ;x++ )
       {
        for (j=0;j<200 ;j++ ){__asm volatile("nop");}
       }


	// Register in 8-Bit-Modus 3x uebertragen, dazwischen warten
	schieberegister_data_schicken(0x38,(1<<1),0x04);
    PORTC &= ~0x07;
    _delay_ms(5);
	//for (x=0;x<40 ;x++ )
     //  {
      //  for (j=0;j<200 ;j++ ){__asm volatile("nop");}

     //  }

	schieberegister_data_schicken(0x38,(1<<1),0x04);
	PORTC &= ~0x07;
	_delay_ms(5);
	//for (x=0;x<40 ;x++ )
     //  {
       // for (j=0;j<200 ;j++ ){__asm volatile("nop");}

   //    }

	schieberegister_data_schicken(0x38,(1<<1),0x04);
	PORTC &= ~0x07;
	_delay_ms(5);
	//for (x=0;x<40 ;x++ )
      // {
        //for (j=0;j<200 ;j++ ){__asm volatile("nop");}

     //  }

    befehl_schicken(0x0f);  		//Display On, Cursor On, Cursor Blink
	befehl_schicken(CLEAR);        // Display loeschen, Cursor Home

}
