/*******************************************************************************
*
* File Name:   display.h
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               Init Display -> display_init(void);
*                                               Positioniert den Cursor -> cursor_position(int zeile, int spalte);
*                                               Schreibt einen String auf das Display -> display_ausgabe(char *format, ...)
*                                               ein befehl an das Display senden -> befehl_schicken(unsigned char befehl)
*                                               
*												                                              
* 2006 Institut fr Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
*
*the display source is based on display.c ver 1.0 by Benjamin Benz 20.12.05 
*Copyright (c) 2005, 59 Temple Place, Suite 330, Boston,MA 02111-1307, USA.
*
****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/
 
#ifndef DISPLAY_H_
#define DISPLAY_H_

#include <avr/io.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include "shift.h"
#include "wait.h"

#define CLEAR 0x01		                  /* Kommando zum Lschen */
#define DISPLAY_CURSORHOME 0x02                	  /* Kommando fr den Cursor */
#define ZEILE_LANGE	20	                      /* Wieviele Zeichen passen in eine Zeile */
#define PUFFER_GROESSE	(ZEILE_LANGE + 1)  /* Puffergroesse fuer eine Zeile in bytes */

/* Init Display */
void display_init(void);

void write_data(char data);

/* Cursorposition*/
void cursor_position(int zeile, int spalte);

/* Schreibt einen String auf das Display.*/
void display_ausgabe(char *format, ...);

/*ein befehl an das Display senden*/
void befehl_schicken(unsigned char befehl);

#endif



