/*******************************************************************************
*
* File Name:   led.c
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               Initialisiert die LEDs -> led_init();
*                                               Zeigt eine 8-Bit Variable mit den LEDs an -> led_set(unsigned int LED);
*												Schaltet eine LED aus -> led_aus(unsigned LED);
*                                               Schaltet eine LED an -> led_ein(unsigned LED);
*
* 2006 Institut fuer Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/

#include "led.h"

/* Zeigt eine 8-Bit Variable mit den LEDs an */
void led_set(unsigned int LED){
	schieberegister_data_schicken(LED,SCHIEBEREGISTER_LED,1<<1);
}

/* Initialisiert die LEDs */
void led_init(void){
	schieberegister_init();
	led_aus(0xFF);
}

/* Schaltet einzelne LEDs anandere werden nicht beeinflusst*/
void led_ein(unsigned int LED){
	LED |= LED;
	led_set(LED);
}

/* Schaltet einzelne LEDs ausandere werden nicht beeinflusst*/
void led_aus(unsigned int LED){
	LED &= ~LED;
	led_set(LED);
}




