/*******************************************************************************
*
* File Name:   led.h
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               Initialisiert die LEDs -> led_init();                                               
*                                               Zeigt eine 8-Bit Variable mit den LEDs an -> led_set(unsigned int LED);
*												Schaltet eine LED aus -> led_aus(unsigned LED); 
*                                               Schaltet eine LED an -> led_ein(unsigned LED);
*                                            
* 2006 Institut fr Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/
 
#ifndef LED_H_
#define LED_H_

#include <avr/io.h>
#include "shift.h"

#define LED_RECHTS	(1<<0)		/*!< LED in Fahrichtung rechts*/
#define LED_LINKS	(1<<1)		/*!< LED in Fahrichtung links*/
#define LED_ROT     (1<<2)		/*!< LED Rot */
#define LED_ORANGE  (1<<3)		/*!< LED Orange */
#define LED_GELB    (1<<4)		/*!< LED Gelb */
#define LED_GRUEN   (1<<5)		/*!< LED Gruen */
#define LED_TUERKIS (1<<6)		/*!< LED Tuerkis */
#define LED_WEISS   (1<<7)		/*!< LED Weiss */
#define LED_ALL      0xFF		/*!< LED Alle */

/* Schaltet eine LED an */
void led_ein(unsigned LED);

/* Initialisiert die LEDs */
void led_init(void);

/* Zeigt eine 8-Bit Variable mit den LEDs an */
void led_set(unsigned int LED);

/* Schaltet eine LED aus */
void led_aus(unsigned LED);

#endif

