/*******************************************************************************
*
* File Name:   motor.c
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               LEFT_VEL, RIGHT_VEL,"+" und "-" bedeutet vor- oder Rueckwaerts -> CTMotor(int left_speed, int right_speed);
*                                               Initialisiert die Motoren -> motor_init();
*
* Copyright (c) 2006 Institut fuer Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/

#include "motor.h"

void motor_init(void){

    DDRD |= 0x30;
    PORTD |= 0x30;             /*Motor(pwm1A,pwm1B) einschalten*/

	DDRC |= 0xc0;

	CTMotor(0,0);
}

/* Setzen motor speed,"-"-> rueckwaertsfahren */
void CTMotor(int left_speed, int right_speed){

    TCCR1A = (1 << WGM10)|(1<<COM1A1)| (1 << COM1B1); //Timer/Counter1 als nicht invertierenden 8-Bit PWM zu verwenden fuer OC1A & OC1B
    TCCR1B = (1<<CS12) | (1<<CS10);                   //einen Takt von CK / 1024 zu generieren
	OCR1A = abs(left_speed);                                //Vergleichswert festlegen
	OCR1B = abs(right_speed);

	if(left_speed > 0 )              // linke Geschwindigkeit positiv
		{PORTC |= 0x40;
		sl=1;}
	if(left_speed < 0 )             // linke Geschwindigkeit negativ
		{PORTC &= ~0x40;
	    sl=0;}
	if(	left_speed == 0 )           // linke Geschwindigkeit = 0
		sl=2;


	if(right_speed < 0 )					// Einer der Motoren ist invertiert, da er ja in die andere Richtung schaut
		{PORTC |= 0x80;
		sr=0;}
	if(right_speed > 0 )
		{PORTC &= ~0x80;
		sr=1;}
	if(	right_speed == 0 )
		sr=2;
}
