/*******************************************************************************
*
* File Name:   shift.c
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               Schieberegister(74HC595)_Initialisieren -> schieberegister_init();
*                                               Schiebt Daten durch eines der drei 74HC595 Schieberegister ->
*                                               schieberegister_data_schicken(unsigned char data, unsigned char latch_data, unsigned char latch_store);
*
* 2006 Institut fuer Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/

#include "shift.h"


/* Initialisert die schieberegister_init*/
void schieberegister_init(){
	DDRC |= 0x1F;		// Alle Pins die Ausgaenge sind und Ausgaenge Schalten
	PORTC &= ~0x1F; 	// Und auf Null
}


/* Schiebt Daten durch eines der drei 74HC595-Schieberegister und den Port danach noch zuruecksetzen*/
void schieberegister_data_schicken(unsigned char data, unsigned char data_send, unsigned char data_schieben){
    int i=0;

	PORTC &= ~0x1F;		                   // und wieder clear
	while(i!=8){
		PORTC |= ((data >> 7)& 0x01);     // SDI=PORTC.0=BitWert (Datenleitung Schieberegister)
		PORTC |= data_send ;	    	   // und ins jeweilige Storageregister senden(SRCLK)
		data= data << 1;		      	   // data links schieben
		PORTC &= ~0x1F;		               // und wieder clear
		i++;
	}

	PORTC |= data_schieben;			       // alles wird ins Output register geschoben -->(RCLK)
	PORTC &= ~0x1F;		                   // und wieder clear
}
