
#define F_CPU 16000000

#define BAUD 9600
#define MY_UBBR ((F_CPU/(8*BAUD))-1)

#include "fahrgeradeaus.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

#define LED_RECHTS	(1<<0)		/*!< LED in Fahrichtung rechts*/
#define LED_LINKS	(1<<1)		/*!< LED in Fahrichtung links*/
#define LED_ROT     (1<<2)		/*!< LED Rot */
#define LED_ORANGE  (1<<3)		/*!< LED Orange */
#define LED_GELB    (1<<4)		/*!< LED Gelb */
#define LED_GRUEN   (1<<5)		/*!< LED Gruen */
#define LED_TUERKIS (1<<6)		/*!< LED Tuerkis */
#define LED_WEISS   (1<<7)		/*!< LED Weiss */
#define LED_ALL      0xFF		/*!< LED Alle */
#define LED_NONE     0x00		/*!< LED Alle */

#define SCHIEBEREGISTER_LED	0x10	  /* Port-Pin fuer SCHIEBEREGISTER_DISPLAY */


void init(void)
{
	// Schieberegister initialisieren
	DDRC |= 0x1F;
	PORTC &= ~0x1F;
}

void shift_leddata(unsigned char data)
{
	// LED-Werte ueber Schieberegister senden
	int i=0;

	PORTC &= ~0x1F;
	while(i!=8){
		PORTC |= ((data >> 7)& 0x01);
		PORTC |= SCHIEBEREGISTER_LED ;
		data  = data << 1;
		PORTC &= ~0x1F;
		i++;
	}
	
	PORTC |= 2;
	PORTC &= ~0x1F;
}

int main(void)
{
	cli();
	init();
	motor_init();
	sensEnc_data[1]=50;
	sensEnc_data[0]=10;
	fahrgeradeaus(45,45);
//	CTMotor(50,50); //left_speed, right_speed als 2 Parameter
/*	while(1)
	{
		shift_leddata(0x01);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x02);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x04);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x08);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x10);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x20);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x40);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
		shift_leddata(0x80);
		for(uint8_t i = 0; i < 100; i++)
		{
			_delay_ms(10);
		}
	}*/
	return 0;
}


