/*******************************************************************************
*
* File Name:   uart.h
* Project  :   c't Bot library
*
*
* Ver.     Date                 Author                    Comments
* -------  ----------   ---------------------   ------------------------------
* 2.00	   28.06.2006   Yang Li & Xingxing Hu   build
*                                               uart_Initialisieren -> uart_init();
*                                               daten senden -> CTWrite(unsigned char *data,unsigned char length); 
*                                               daten empfangen -> CTRead(unsigned char *data, unsigned char length);
*                                               print -> PrintInt(int wert);
*												                                              
* Copyright (c) 2006 Institut fr Informatik, Tu-Clausthal
*****************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version.                                                    *
 ***************************************************************************/
 
#ifndef UART_H_
#define UART_H_

#include <stdio.h> 
#include <stdlib.h> 
#include <ctype.h> 
#include <avr/io.h> 
#include <avr/delay.h> 
#include <avr/interrupt.h> 
#include <avr/signal.h>

#define SYSCLK		16000000L
#define BAUD	    19200L
#define UBRR_BAUD	((SYSCLK / (16*BAUD)) - 1)

/*Initialisiere UART*/
void uart_init(void);

/* Funktion fr serielle Kommunikation */
void CTWrite(unsigned char *data,unsigned char length);
/* timeout = 0 => bloking mode !!! */
void CTRead(unsigned char *data, unsigned char length);

/*output*/
void PrintInt(long int wert);

// Zeichen senden 
int uart_putc(unsigned char c); 

// String senden 
void uart_puts (char *s); 

//Zeichen empfangen 
uint8_t uart_getc (void); 

#endif
