#include <stdlib.h>
#include <avr/io.h>
#include <avr/signal.h>
#include <avr/interrupt.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "led.h"
#include "ena.h"
#include "uart.h"
#include "wait.h"
#include "init.h"
#include "maus.h"
#include "menue.h"
#include "shift.h"
#include "motor.h"
#include "timer.h"
#include "display.h"
#include "sensoren.h"
#include "vorbereitung.h"
#include "geschwindigkeitsteuerung.h"

volatile int adc_wert[8],channel;

SIGNAL (SIG_OUTPUT_COMPARE2){
    systemzeit_isr();
	encoder_isr();
}

/* Interrupt wird ausgeloest sobald neue Daten im USART-Empfangspuffer liegen */
SIGNAL (SIG_UART_RECV)
{
    receive_char=1;
    buffer[Buffer_Index]=UDR;        // Buffer-Index, globale variable.
    uart_putc(buffer[Buffer_Index]);
    Buffer_Index++;
        if(Buffer_Index>3)
        {
        	Buffer_Index=0;
		   sendflag=0;
        }
}

ISR(ADC_vect){
	adc_wert[channel] = ADCL + (ADCH << 8);
	channel++;
	if(channel>=8)
	channel=0;
    ADMUX = (1<<REFS0) | (channel & 0x07);         // interne Referenzspannung, rechts Ausrichtung
	ADCSRA |= (1 << ADSC);
}

//void display_anzeige(void){
//
//	switch (buffer[0])
//	{
//    case 'a':
//        befehl_schicken(CLEAR); // Display loeschen, Cursor Home
//	    cursor_position(1,1);
//	    display_ausgabe("Distanz=%d %d ",entfernung(adc_wert[0]),entfernung(adc_wert[1]));
//	    cursor_position(2,1);
//	    display_ausgabe("Encoder=%ld %ld ",sensEnc_data[0],sensEnc_data[1]);
//	    cursor_position(3,1);
//	    display_ausgabe("Licht=%d %d ",adc_wert[4],adc_wert[5]);
//	    cursor_position(4,1);
//	    display_ausgabe("Kanten=%d %d ",adc_wert[6],adc_wert[7]);
//		wait(10);
//	break;
//
//	case 'b':
//	    befehl_schicken(CLEAR); // Display loeschen, Cursor Home
//		cursor_position(1,1);
//		display_ausgabe("Zeit=%04d ", zeit_s());
//		cursor_position(2,1);
//		display_ausgabe("Encoder=%ld %ld ",sensEnc_data[0],sensEnc_data[1]);
//		cursor_position(3,1);
//		display_ausgabe("Speed= %04d %04d ",Speed_l,Speed_r);
//		cursor_position(4,1);
//		display_ausgabe("Linie=%d %d ",adc_wert[2],adc_wert[3]);
//		wait(10);
//	break;
//
//	case 'c':
//	    befehl_schicken(CLEAR); // Display loeschen, Cursor Home
//		cursor_position(1,1);
//		display_ausgabe("Klappen=%d ", Klappesensor_data[0]);
//		cursor_position(2,1);
//		display_ausgabe("Transportfach=%d ", Transportfachsensor_data[0]);
//		cursor_position(3,1);
//		display_ausgabe("Maus=%ld %ld",Maus_X, Maus_Y);
//        wait(50);
//	break;
//
//	}
//}

void HyperTerminal_anzeige(void){

  CTWrite("\n\n\n\n",4);
  CTWrite("Distanzsensor  links,rechts            ",39);
  PrintInt(entfernung(adc_wert[0]));			// linker Distanzsensor
  CTWrite("cm        ",10);
  PrintInt(entfernung(adc_wert[1]));			// rechter Distanzsensor
  CTWrite("cm\n\n",4);

  CTWrite("Liniensensor   links,rechts            ",39);
  PrintInt(adc_wert[2]*4.8828125);                      // linker Liniensensor
  CTWrite("mv    ",6);
  PrintInt(adc_wert[3]*4.8828125);                      // rechter Liniensensor
  CTWrite("mv\n\n",4);

  CTWrite("Lichtsensor    links,rechts            ",39);
  PrintInt(adc_wert[4]*4.8828125);
  CTWrite("mv       ",9);
  PrintInt(adc_wert[5]*4.8828125);
  CTWrite("mv\n\n",4);

  CTWrite("Kantensensor   links,rechts            ",39);
  PrintInt(adc_wert[6]*4.8828125);
  CTWrite("mv    ",6);
  PrintInt(adc_wert[7]*4.8828125);
  CTWrite("mv\n\n",4);

  CTWrite("\n",1);
  CTWrite("Encoderzahl    links,rechts            ",39);
  PrintInt(sensEnc_data[0]);
  CTWrite("      ",6);
  PrintInt(sensEnc_data[1]);
  CTWrite("\n\n",2);

  CTWrite("\n",1);
  CTWrite("Maussensor     x_richtung,y_richtung   ",39);
  PrintInt(Maus_X);
  CTWrite("      ",6);
  PrintInt(Maus_Y);
  CTWrite("\n\n\n\n", 4);

  wait(50);            // vorher 10, so lesbarer
}

void kollisionserkennung(void){

int left_speed=40,right_speed=40,minus_speed=-40;

	if (abs(entfernung(adc_wert[1]))> 20 && abs(entfernung(adc_wert[0]))> 20) //wenn rechter u. linker Distanzsensor > 20
	{

	    led_aus(LED_ALL);
		CTMotor(left_speed,right_speed);   // geradeaus (kein wirkliches geradeaus, eher eine Kurve)
	}

    	else if (abs(entfernung(adc_wert[0])) <= 20 && abs(entfernung(adc_wert[1]))<= 20)// wenn beide <= 20
	{

		CTMotor(left_speed,minus_speed);   // flotte Rechtsdrehung

		led_set(LED_RECHTS);               // Rechtssblinker LED an  (das ist neu, vorher LED_LINKS)

		if (abs(entfernung(adc_wert[1]))< 20 && abs(entfernung(adc_wert[0]))< 20 && abs(entfernung(adc_wert[0]))==abs(entfernung(adc_wert[1])))
		{                                     // wenn beide Distanzsensoren < 20 & Distanz bei beiden gleich

            	led_aus(LED_ALL);
		    	CTMotor(minus_speed,minus_speed);       // rückwärts (das ist neu)
	    	}
	}

	else if ( abs(entfernung(adc_wert[0]))<= 20 &&  abs(entfernung(adc_wert[1]))> 20){ // wenn linker Sens. <= 20  &  rechter > 20

		CTMotor(left_speed,minus_speed);    // flotte Rechtsdrehung (logisch)
		led_set(LED_RECHTS);                // Rechtsblinker LED an

		if (abs(entfernung(adc_wert[1]))< 20 && abs(entfernung(adc_wert[0]))< 20 && abs(entfernung(adc_wert[0]))==abs(entfernung(adc_wert[1]))){
						             // wenn beide Sensoren < 20 &  Distanz bei beiden gleich
	        led_aus(LED_ALL);
	        CTMotor(minus_speed,minus_speed); // rückwärts (das ist neu)
	    }
	}

	else if (abs(entfernung(adc_wert[1])) <= 20 && abs(entfernung(adc_wert[0]))> 20){ // wenn rechter Sens. <= 20  &  linker Sens. > 20

		CTMotor(minus_speed,right_speed);   // flotte Linksdrehung (logisch)
		led_set(LED_LINKS);                 // Linksblinker LED an

		if (abs(entfernung(adc_wert[1]))< 20 && abs(entfernung(adc_wert[0]))< 20 && abs(entfernung(adc_wert[0]))==abs(entfernung(adc_wert[1]))){
				                            // wenn beide Sensoren < 20  &  Distanz bei beiden gleich
	        led_aus(LED_ALL);
		    CTMotor(minus_speed,minus_speed); // rückwärts (das ist neu)
	    }
	}
}

void lichtverfolgung(void){

int l_speed=100,r_speed=100;

	if ((adc_wert[5]-adc_wert[4]) < -40){    // Rechte Seite sehr heller als Linke
	    led_set(LED_RECHTS);				// Rechtsblinke LED an
		CTMotor(l_speed,40);			   // bot soll sich nun nach rechts drehen

	}

	if ((adc_wert[5]-adc_wert[4]) > 40){     // Linke Seite sehr heller als Rechte
	    led_set(LED_LINKS);					// Linksblinke LED an
	    CTMotor(40, r_speed);			   // bot soll sich nun nach links drehen
	}

	if((adc_wert[5]-adc_wert[4]) > -40 && (adc_wert[5]-adc_wert[4]) < 40){ // Beide Seiten ungefaehr gleich hell
	    led_set(LED_LINKS|LED_RECHTS);
		CTMotor(l_speed,r_speed);					// geradeaus fahren
	}
}

void spurverfolgung(void){



		if (abs(adc_wert[2])<200 && (abs(adc_wert[3])>200 && abs(adc_wert[3])<800))   //wenn der linke Liniensensor weissen Untergr. detektiert &&  der rechte schwarz detektiert,
	    	{
			CTMotor(23,-23);			    // dann sollen die Motoren mit (23,-23) eine fluessige Drehung nach rechts vollfuehren,
			led_set(LED_RECHTS);
		}

		else if (abs(adc_wert[3])<200 && (abs(adc_wert[2])>200 && abs(adc_wert[2])<800))    // wenn der rechte Liniensensor weiss detektiert & der linke schwarz,
		{
			CTMotor(-23,23);			 //dann fluessige Drehung nach links
			led_set(LED_LINKS);
		}

		else if (abs(adc_wert[2])>200 && abs(adc_wert[2])<800 &&abs(adc_wert[3])>200 && abs(adc_wert[3])<800) // wenn beide Sensoren schwarz,
	    	{
			CTMotor(15,15);										       // dann mittellangsame Geradeausfahrt
			led_set(LED_LINKS|LED_RECHTS);
		}
		else if (abs(adc_wert[2])<200 && abs(adc_wert[3])<200)   //wenn beide Sensoren weissen Untergrund detektieren,
		{
			CTMotor(-10,-9);                                  // langsame Rueckwaertsfahrt mit sehr leichter Drehung in Fahrtrichtung nach rechts
		}
		else if (abs(adc_wert[2])>800 || abs(adc_wert[3])>800)   // wenn einer der Sensoren eine Kante erkennt
	    	{
			CTMotor(0,0);					  // dann Motoren aus
			led_aus(LED_ALL);
}

}



int main(void)
{
    cli();
    init();
	CTMotor(0,0);
	sensoren_isr();
	channel=0;
	ADCSRA |= (1<<ADIE);
	CTWrite("\f",1);
	menue();
	vorbereitung();
    sei();

   while(1)
   {
	if(buffer[0]>48 && buffer[0]<57){  // nur wenn buffer[0] eine Zahl erhält, dann Geschwindigkeitssteuerung aktivieren
		speed_controll();
	}
	else {
		switch(buffer[0])
		{
		    case 'a':
		        befehl_schicken(CLEAR); // Display loeschen, Cursor Home
			    cursor_position(1,1);
			    display_ausgabe("Distanz=%d %d ",entfernung(adc_wert[0]),entfernung(adc_wert[1]));
			    cursor_position(2,1);
			    display_ausgabe("Encoder=%ld %ld ",sensEnc_data[0],sensEnc_data[1]);
			    cursor_position(3,1);
			    display_ausgabe("Licht=%d %d ",adc_wert[4],adc_wert[5]);
			    cursor_position(4,1);
			    display_ausgabe("Kanten=%d %d ",adc_wert[6],adc_wert[7]);
			    Buffer_Index = 0; //  jetzt nur noch zweimal Buchstabe drücken dann Displaywechsel
				wait(10);

			break;

			case 'b':
			    befehl_schicken(CLEAR); // Display loeschen, Cursor Home
				cursor_position(1,1);
				display_ausgabe("Zeit=%04d ", zeit_s());
				cursor_position(2,1);
				display_ausgabe("Encoder=%ld %ld ",sensEnc_data[0],sensEnc_data[1]);
				cursor_position(3,1);
				display_ausgabe("Speed= %04d %04d ",Speed_l,Speed_r);
				cursor_position(4,1);
				display_ausgabe("Linie=%d %d ",adc_wert[2],adc_wert[3]);
				Buffer_Index = 0;
				wait(10);

			break;

			case 'c':
			    befehl_schicken(CLEAR); // Display loeschen, Cursor Home
				cursor_position(1,1);
				display_ausgabe("Klappen=%d ", Klappesensor_data[0]);
				cursor_position(2,1);
				display_ausgabe("Transportfach=%d ", Transportfachsensor_data[0]);
				cursor_position(3,1);
				display_ausgabe("Maus=%ld %ld",Maus_X, Maus_Y);
				Buffer_Index = 0;
		        wait(10);

			break;

			case 'h':
				Buffer_Index = 0;
				HyperTerminal_anzeige();
			break;

			case 'f':
				Buffer_Index = 0;
				spurverfolgung();
			break;

			case 'k':
				Buffer_Index = 0;
				kollisionserkennung();
			break;

			case 'l':
				Buffer_Index = 0;
				lichtverfolgung();
			break;

			default:
			break;
		}
//		if(buffer[0]=='h'){
//			HyperTerminal_anzeige();
//		}
//
//		if(buffer[0]=='f'){
//			spurverfolgung();
//		}
//
//		if(buffer[0]=='k'){
//
//			kollisionserkennung();
//		}
//
//		if(buffer[0]=='l'){
//
//			lichtverfolgung();
//		}


		position_bestimmung();
//		display_anzeige();
	}
 }

   return 0;
}



